<?php
/**
*
* @package phpBB3
* @version $Id: index.php,v 1.176 2007/10/05 14:30:06 poppertom69 Exp $
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);
$user->setup('mods/bbcode_perm');

$version = '1.0.2';

if (confirm_box(true))
{
	//Setup $auth_admin class so we can add permission options
	include($phpbb_root_path . 'includes/acp/auth.' . $phpEx);
	
	$perm = array(
		array('Administrators'),
		array('Moderators'),
		array('Supporters'),
		array('Standard users'),			
	);

	foreach ($perm as $value)
	{	
		$auth_admin = new auth_admin();
		// Add permission for manage cvsdb
		$auth_admin->acl_add_option(array(
			'local'		=> array(),
			'global'	=> array('u_bbcode_group_' . $value[0] . ''),
		));	
	
		$sql_ary = array(
			'group_name'	=>	$value[0],
			'allow_group'	=>	'1',
		);
		$db->sql_query('INSERT INTO ' . BBCODE_EXTENSION_GROUPS . ' ' . $db->sql_build_array('INSERT', $sql_ary));
		$db->sql_freeresult($result);		
	}
	trigger_error(sprintf($user->lang['BBCODE_PERM_INSTALLED'], $version));
}
else
{
	confirm_box(false, 'INSTALL_BBCODE_PERM');
}

?>