<?php
/**
*
* @package acp
* @version $Id: acp_bbcode_permissions.php 8495 2008-04-07 17:39:23Z acydburn $ Altered by Poppertom69
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_bbcode_permissions
{
	var $u_action;
	var $new_config;

	function main($id, $mode)
	{
		global $db, $user, $template, $cache;
		global $phpbb_admin_path, $phpbb_root_path, $phpEx;

		$user->add_lang(array('posting', 'viewtopic', 'acp/attachments', 'mods/bbcode_perm'));

		$error = $notify = array();
		$submit = (isset($_POST['submit'])) ? true : false;
		$action = request_var('action', '');

		$form_key = 'acp_bbcode_perm';
		add_form_key($form_key);

		if ($submit && !check_form_key($form_key))
		{
			trigger_error($user->lang['FORM_INVALID'] . adm_back_link($this->u_action), E_USER_WARNING);
		}

		switch ($mode)
		{
			case 'bbcode_extensions':
				$l_title = 'ACP_MANAGE_BBCODE_EXTENSIONS';
			break;

			case 'bbcode_ext_groups':
				$l_title = 'ACP_BBCODE_EXTENSION_GROUPS';
			break;
			
			default:
				trigger_error('NO_MODE', E_USER_ERROR);
			break;
		}

		$this->tpl_name = 'acp_bbcode_perm';
		$this->page_title = $l_title;

		$template->assign_vars(array(
			'L_TITLE'			=> $user->lang[$l_title],
			'L_TITLE_EXPLAIN'	=> $user->lang[$l_title . '_EXPLAIN'],
			'U_ACTION'			=> $this->u_action)
		);

		switch ($mode)
		{
			case 'bbcode_extensions':				
				switch ($action)
				{ 						
					case 'view':
						$group_ex_id = request_var('g_id', '');
						$group_ex_name = request_var('g_name', '');		
						$select_bbcode = request_var('select_bbcode', '');	
						$extension_id = request_var('extension', '');
						$extension_name = request_var('extension_name', '');						
						
						if ($extension_id)
						{
							$sql = 'DELETE FROM ' . BBCODE_EXTENSIONS . "
								WHERE extension_id = '" . $db->sql_escape($extension_id) . "'";
							$db->sql_query($sql);
							
							$notify[] = sprintf($user->lang['BBCODE_DELETE_GROUP'], $extension_name, $group_ex_name);
						}
						
						if ($submit)
						{
							$sql = 'SELECT bbcode_id
								FROM ' . BBCODES_TABLE . "
								WHERE bbcode_tag = '" . $db->sql_escape($select_bbcode) . "'";
							$result = $db->sql_query($sql);
							$bbcode_id =  $db->sql_fetchfield('bbcode_id');
							$db->sql_freeresult($result);
						
							$sql_ary = array(
								'group_id'		=> (int) $group_ex_id,
								'extension'		=> $select_bbcode,
								'group_name'	=> $group_ex_name,
								'bbcode_id'		=> (int) $bbcode_id,
							);

							//Insert the data into the blog table
							$sql = 'INSERT INTO ' . BBCODE_EXTENSIONS . ' ' . $db->sql_build_array('INSERT', $sql_ary);
							$db->sql_query($sql);
							
							$notify[] = sprintf($user->lang['BBCODE_ADD_GROUP'], $select_bbcode, $group_ex_name);
						}
						
						$template->assign_vars(array(
							'S_EXTENSIONS_VIEW_GROUP'	=> true,	
							'TITLE_GROUP' 				=> $group_ex_name,
							'BBCODE_SELECT'				=> $this->bbcode_select('select_bbcode', 'bbcode'),
							'U_FORM_ACTION'				=> $this->u_action . "&amp;action=view&amp;g_id=$group_ex_id&amp;g_name=$group_ex_name",
						));
						
						$sql = 'SELECT *
							FROM ' . BBCODE_EXTENSIONS . "
							WHERE group_id = '" . $db->sql_escape($group_ex_id) . "'
							ORDER BY extension";
						$result = $db->sql_query($sql);
						$rows = $db->sql_fetchrowset($result);
						foreach ($rows as $row)		
						{
							$template->assign_block_vars('extensions', array(									
								'EXTENSION_NAME'	=> $row['extension'],	
								'U_BBCODE'			=> $this->u_action . "&amp;action=view&amp;g_id=$group_ex_id&amp;g_name=$group_ex_name&amp;extension={$row['extension_id']}&amp;extension_name={$row['extension']}",
							));						
						}
						$db->sql_freeresult($result);
					break;					
					default:									
						$template->assign_vars(array(
							'S_EXTENSIONS'	=> true,
						));

						$sql = 'SELECT *
							FROM ' . BBCODE_EXTENSION_GROUPS . '
							ORDER BY group_id';
						$result = $db->sql_query($sql);
						$rows = $db->sql_fetchrowset($result);
						foreach ($rows as $row)		
						{
								$template->assign_block_vars('extensions', array(
									'GROUP_ID'		=> $row['group_id'],
									'GROUP_NAME'	=> $row['group_name'],	
									'U_BBCODE'		=> $this->u_action . "&amp;action=view&amp;g_id={$row['group_id']}&amp;g_name={$row['group_name']}",
								));							
						}
						$db->sql_freeresult($result);
					break;
				}

			break;

			case 'bbcode_ext_groups':

				$template->assign_var('S_EXTENSION_GROUPS', true);

				if ($submit)
				{
					$action = request_var('action', '');
					$group_id = request_var('g', 0);

					if ($action != 'add' && $action != 'edit')
					{
						trigger_error('NO_MODE', E_USER_ERROR);
					}

					if (!$group_id && $action == 'edit')
					{
						trigger_error($user->lang['NO_EXT_GROUP_SPECIFIED'] . adm_back_link($this->u_action), E_USER_WARNING);
					}

					if ($group_id)
					{
						$sql = 'SELECT *
							FROM ' . BBCODE_EXTENSION_GROUPS . "
							WHERE group_id = '" . $db->sql_escape($group_id) . "'";
						$result = $db->sql_query($sql);
						$ext_row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);

						if (!$ext_row)
						{
							trigger_error($user->lang['NO_EXT_GROUP_SPECIFIED'] . adm_back_link($this->u_action), E_USER_WARNING);
						}
					}
					else
					{
						$ext_row = array();
					}

					$group_name = utf8_normalize_nfc(request_var('group_name', '', true));
					$new_group_name = ($action == 'add') ? $group_name : (($ext_row['group_name'] != $group_name) ? $group_name : '');

					if (!$group_name)
					{
						$error[] = $user->lang['NO_EXT_GROUP_NAME'];
					}

					// Check New Group Name
					if ($new_group_name)
					{
						$sql = 'SELECT group_id
							FROM ' . BBCODE_EXTENSION_GROUPS . "
							WHERE LOWER(group_name) = '" . $db->sql_escape(utf8_strtolower($new_group_name)) . "'";
						$result = $db->sql_query($sql);

						if ($db->sql_fetchrow($result))
						{
							$error[] = sprintf($user->lang['BBCODE_EXTENSION_GROUP_EXIST'], $new_group_name);
						}
						$db->sql_freeresult($result);
					}

					if (!sizeof($error))
					{
						// Ok, build the update/insert array
						$allow_group	= (isset($_POST['allow_group'])) ? true : false;

						$group_ary = array(
							'group_name'	=> $group_name,
							'allow_group'	=> ($allow_group) ? 1 : 0,
						);

						$sql = ($action == 'add') ? 'INSERT INTO ' . BBCODE_EXTENSION_GROUPS . ' ' : 'UPDATE ' . BBCODE_EXTENSION_GROUPS . ' SET ';
						$sql .= $db->sql_build_array((($action == 'add') ? 'INSERT' : 'UPDATE'), $group_ary);
						$sql .= ($action == 'edit') ? " WHERE group_id = $group_id" : '';

						$db->sql_query($sql);

						if ($action == 'add')
						{
							$group_id = $db->sql_nextid();
						}
						
						//Setup $auth_admin class so we can add permission options
						include($phpbb_root_path . 'includes/acp/auth.' . $phpEx);
						$auth_admin = new auth_admin();
		
						// Add permission for manage cvsdb
						$auth_admin->acl_add_option(array(
							'local'		=> array(),
							'global'	=> array('u_bbcode_group_' . $group_name . '')
						));	

						add_log('admin', 'LOG_BBCODE_ADD/UP', $group_name);
					}

					$extension_list = request_var('extensions', array(0));

					if ($action == 'edit' && sizeof($extension_list))
					{
						$sql = 'UPDATE ' . BBCODE_EXTENSIONS . "
							SET group_id = 0
							WHERE group_id = '" . $db->sql_escape($group_id) . "'";
						$db->sql_query($sql);
					}

					if (sizeof($extension_list))
					{
						$sql = 'UPDATE ' . BBCODE_EXTENSIONS . "
							SET group_id = '" . $db->sql_escape($group_id) ."'
							WHERE " . $db->sql_in_set('extension_id', $extension_list);
						$db->sql_query($sql);
					}

					$cache->destroy('_extensions');

					if (!sizeof($error))
					{
						$notify[] = $user->lang['SUCCESS_EXTENSION_GROUP_' . strtoupper($action)];
						$notify[] .= sprintf($user->lang['ACP_BBCODE_EXTENSION_GROUPS_CODE'], $group_name, $group_name);
					}
				}

				$group_id = request_var('g', 0);
				$action = (isset($_POST['add'])) ? 'add' : $action;

				switch ($action)
				{
					case 'delete':

						if (confirm_box(true))
						{
							$sql = 'SELECT group_name
								FROM ' . BBCODE_EXTENSION_GROUPS . "
								WHERE group_id = '" . $db->sql_escape($group_id) . "'";
							$result = $db->sql_query($sql);
							$group_name = (string) $db->sql_fetchfield('group_name');
							$db->sql_freeresult($result);

							$sql = 'DELETE
								FROM ' . BBCODE_EXTENSION_GROUPS . "
								WHERE group_id = '" . $db->sql_escape($group_id) . "'";
							$db->sql_query($sql);
							
							$sql = 'DELETE
								FROM ' . ACL_OPTIONS_TABLE . "
								WHERE auth_option = 'u_bbcode_group_" . $db->sql_escape($group_name) . "'";
							$db->sql_query($sql);

							// Set corresponding Extensions to a pending Group
							$sql = 'UPDATE ' . BBCODE_EXTENSIONS . "
								SET group_id = 0
								WHERE group_id = '" . $db->sql_escape($group_id) . "'";
							$db->sql_query($sql);

							add_log('admin', 'LOG_ATTACH_EXTGROUP_DEL', $group_name);

							$cache->destroy('_extensions');

							trigger_error($user->lang['BBCODE_EXTENSION_GROUP_DELETED'] . adm_back_link($this->u_action));
						}
						else
						{
							confirm_box(false, $user->lang['CONFIRM_OPERATION'], build_hidden_fields(array(
								'i'			=> $id,
								'mode'		=> $mode,
								'group_id'	=> $group_id,
								'action'	=> 'delete',
							)));
						}

					break;

					case 'edit':

						if (!$group_id)
						{
							trigger_error($user->lang['NO_EXT_GROUP_SPECIFIED'] . adm_back_link($this->u_action), E_USER_WARNING);
						}

						$sql = 'SELECT *
							FROM ' . BBCODE_EXTENSION_GROUPS . "
							WHERE group_id = '" . $db->sql_escape($group_id) . "'";
						$result = $db->sql_query($sql);
						$ext_group_row = $db->sql_fetchrow($result);
						$db->sql_freeresult($result);						

					// no break;

					case 'add':

						if ($action == 'add')
						{
							$ext_group_row = array(
								'group_name'	=> utf8_normalize_nfc(request_var('group_name', '', true)),
								'allow_group'	=> 1,
							);

						}

						$extensions = array();

						$sql = 'SELECT *
							FROM ' . BBCODE_EXTENSIONS . "
							WHERE group_id = '" . $db->sql_escape($group_id) . "'
								OR group_id = 0
							ORDER BY extension";
						$result = $db->sql_query($sql);
						$extensions = $db->sql_fetchrowset($result);
						$db->sql_freeresult($result);

						$i = 0;
						$assigned_extensions = '';
						foreach ($extensions as $num => $row)
						{
							if ($row['group_id'] == $group_id && $group_id)
							{
								$assigned_extensions .= ($i) ? ', ' . $row['extension'] : $row['extension'];
								$i++;
							}
						}

						$s_extension_options = '';
						foreach ($extensions as $row)
						{
							$s_extension_options .= '<option' . ((!$row['group_id']) ? ' class="disabled"' : '') . ' value="' . $row['extension_id'] . '"' . (($row['group_id'] == $group_id && $group_id) ? ' selected="selected"' : '') . '>' . $row['extension'] . '</option>';
						}

						$template->assign_vars(array(
							'PHPBB_ROOT_PATH'		=> $phpbb_root_path,							
							'ACTION'				=> $action,
							'GROUP_ID'				=> $group_id,
							'GROUP_NAME'			=> $ext_group_row['group_name'],
							'ALLOW_GROUP'			=> $ext_group_row['allow_group'],							
							'ASSIGNED_EXTENSIONS'	=> $assigned_extensions,
							
							'S_EXTENSION_OPTIONS'		=> $s_extension_options,
							'S_EDIT_GROUP'				=> true,							

							'U_EXTENSIONS'		=> append_sid("{$phpbb_admin_path}index.$phpEx", "i=$id&amp;mode=bbcode_extensions"),
							'U_BACK'			=> $this->u_action,

							'L_LEGEND'			=> $user->lang[strtoupper($action) . '_EXTENSION_GROUP'])
						);						

					break;
				}

				$sql = 'SELECT *
					FROM ' . BBCODE_EXTENSION_GROUPS . '
					ORDER BY group_name';
				$result = $db->sql_query($sql);

				$old_allow_group = 1;
				while ($row = $db->sql_fetchrow($result))
				{
					$s_add_spacer = ($old_allow_group != $row['allow_group']) ? true : false;

					$template->assign_block_vars('groups', array(
						'S_ADD_SPACER'		=> $s_add_spacer,
						'S_GROUP_ALLOWED'	=> ($row['allow_group']) ? true : false,

						'U_EDIT'		=> $this->u_action . "&amp;action=edit&amp;g={$row['group_id']}",
						'U_DELETE'		=> $this->u_action . "&amp;action=delete&amp;g={$row['group_id']}",

						'GROUP_NAME'	=> $row['group_name'],
						)
					);

					$old_allow_group = $row['allow_group'];
				}
				$db->sql_freeresult($result);

			break;			
		}

		if (sizeof($error))
		{
			$template->assign_vars(array(
				'S_WARNING'		=> true,
				'WARNING_MSG'	=> implode('<br />', $error))
			);
		}

		if (sizeof($notify))
		{
			$template->assign_vars(array(
				'S_NOTIFY'		=> true,
				'NOTIFY_MSG'	=> implode('<br />', $notify))
			);
		}
	}
	
	function bbcode_select($select_name, $key = '')
	{
		global $db, $user;

		$bbcode_select = '<select name="' . $select_name . '"' . (($key) ? ' id="' . $key . '"' : '') . '>';

		$sql = 'SELECT bbcode_tag
			FROM ' . BBCODES_TABLE . '
			ORDER BY bbcode_tag';
		$result = $db->sql_query($sql);

		$bbcode_name = array();
		while ($row = $db->sql_fetchrow($result))
		{
			$bbcode_name[] = $row;
		}
		$db->sql_freeresult($result);

		for ($i = 0; $i < sizeof($bbcode_name); $i++)
		{
			$bbcode_select .= '<option value="' . $bbcode_name[$i]['bbcode_tag'] . '">' . $bbcode_name[$i]['bbcode_tag'] . '</option>';
		}

		$bbcode_select .= '</select>';

		return $bbcode_select;
	}
	
}

?>